// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package healthcheck

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion7

// HCMonitorServiceClient is the client API for HCMonitorService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type HCMonitorServiceClient interface {
	WatchResults(ctx context.Context, in *WatchResultsRequest, opts ...grpc.CallOption) (HCMonitorService_WatchResultsClient, error)
	CreateHealthcheck(ctx context.Context, in *CreateHealthcheckRequest, opts ...grpc.CallOption) (*CreateHealthcheckResponse, error)
	DeleteHealthcheck(ctx context.Context, in *DeleteHealthcheckRequest, opts ...grpc.CallOption) (*DeleteHealthcheckResponse, error)
}

type hCMonitorServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewHCMonitorServiceClient(cc grpc.ClientConnInterface) HCMonitorServiceClient {
	return &hCMonitorServiceClient{cc}
}

func (c *hCMonitorServiceClient) WatchResults(ctx context.Context, in *WatchResultsRequest, opts ...grpc.CallOption) (HCMonitorService_WatchResultsClient, error) {
	stream, err := c.cc.NewStream(ctx, &_HCMonitorService_serviceDesc.Streams[0], "/healthcheck.HCMonitorService/WatchResults", opts...)
	if err != nil {
		return nil, err
	}
	x := &hCMonitorServiceWatchResultsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type HCMonitorService_WatchResultsClient interface {
	Recv() (*WatchResultsResponse, error)
	grpc.ClientStream
}

type hCMonitorServiceWatchResultsClient struct {
	grpc.ClientStream
}

func (x *hCMonitorServiceWatchResultsClient) Recv() (*WatchResultsResponse, error) {
	m := new(WatchResultsResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *hCMonitorServiceClient) CreateHealthcheck(ctx context.Context, in *CreateHealthcheckRequest, opts ...grpc.CallOption) (*CreateHealthcheckResponse, error) {
	out := new(CreateHealthcheckResponse)
	err := c.cc.Invoke(ctx, "/healthcheck.HCMonitorService/CreateHealthcheck", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *hCMonitorServiceClient) DeleteHealthcheck(ctx context.Context, in *DeleteHealthcheckRequest, opts ...grpc.CallOption) (*DeleteHealthcheckResponse, error) {
	out := new(DeleteHealthcheckResponse)
	err := c.cc.Invoke(ctx, "/healthcheck.HCMonitorService/DeleteHealthcheck", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// HCMonitorServiceServer is the server API for HCMonitorService service.
// All implementations must embed UnimplementedHCMonitorServiceServer
// for forward compatibility
type HCMonitorServiceServer interface {
	WatchResults(*WatchResultsRequest, HCMonitorService_WatchResultsServer) error
	CreateHealthcheck(context.Context, *CreateHealthcheckRequest) (*CreateHealthcheckResponse, error)
	DeleteHealthcheck(context.Context, *DeleteHealthcheckRequest) (*DeleteHealthcheckResponse, error)
	mustEmbedUnimplementedHCMonitorServiceServer()
}

// UnimplementedHCMonitorServiceServer must be embedded to have forward compatible implementations.
type UnimplementedHCMonitorServiceServer struct {
}

func (UnimplementedHCMonitorServiceServer) WatchResults(*WatchResultsRequest, HCMonitorService_WatchResultsServer) error {
	return status.Errorf(codes.Unimplemented, "method WatchResults not implemented")
}
func (UnimplementedHCMonitorServiceServer) CreateHealthcheck(context.Context, *CreateHealthcheckRequest) (*CreateHealthcheckResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateHealthcheck not implemented")
}
func (UnimplementedHCMonitorServiceServer) DeleteHealthcheck(context.Context, *DeleteHealthcheckRequest) (*DeleteHealthcheckResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteHealthcheck not implemented")
}
func (UnimplementedHCMonitorServiceServer) mustEmbedUnimplementedHCMonitorServiceServer() {}

// UnsafeHCMonitorServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to HCMonitorServiceServer will
// result in compilation errors.
type UnsafeHCMonitorServiceServer interface {
	mustEmbedUnimplementedHCMonitorServiceServer()
}

func RegisterHCMonitorServiceServer(s *grpc.Server, srv HCMonitorServiceServer) {
	s.RegisterService(&_HCMonitorService_serviceDesc, srv)
}

func _HCMonitorService_WatchResults_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(WatchResultsRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(HCMonitorServiceServer).WatchResults(m, &hCMonitorServiceWatchResultsServer{stream})
}

type HCMonitorService_WatchResultsServer interface {
	Send(*WatchResultsResponse) error
	grpc.ServerStream
}

type hCMonitorServiceWatchResultsServer struct {
	grpc.ServerStream
}

func (x *hCMonitorServiceWatchResultsServer) Send(m *WatchResultsResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _HCMonitorService_CreateHealthcheck_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateHealthcheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HCMonitorServiceServer).CreateHealthcheck(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/healthcheck.HCMonitorService/CreateHealthcheck",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HCMonitorServiceServer).CreateHealthcheck(ctx, req.(*CreateHealthcheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _HCMonitorService_DeleteHealthcheck_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteHealthcheckRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(HCMonitorServiceServer).DeleteHealthcheck(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/healthcheck.HCMonitorService/DeleteHealthcheck",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(HCMonitorServiceServer).DeleteHealthcheck(ctx, req.(*DeleteHealthcheckRequest))
	}
	return interceptor(ctx, in, info, handler)
}

var _HCMonitorService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "healthcheck.HCMonitorService",
	HandlerType: (*HCMonitorServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateHealthcheck",
			Handler:    _HCMonitorService_CreateHealthcheck_Handler,
		},
		{
			MethodName: "DeleteHealthcheck",
			Handler:    _HCMonitorService_DeleteHealthcheck_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "WatchResults",
			Handler:       _HCMonitorService_WatchResults_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "pkg/protos/healthcheck.proto",
}
